Irrlicht Engine: irr::scene::IParticleSystemSceneNode Class Reference

Home | Namespaces | Hierarchy | Alphabetical List | Class list | Files | Namespace Members | Class members | File members | Tutorials

# irr::scene::IParticleSystemSceneNode Class Reference

A particle system scene node for creating snow, fire, exlosions, smoke... More...

`#include <IParticleSystemSceneNode.h>`

Inheritance diagram for irr::scene::IParticleSystemSceneNode:

List of all members.

## Public Member Functions
virtual void | addAffector (IParticleAffector *affector)=0
| Adds new particle effector to the particle system.
virtual IParticleAnimatedMeshSceneNodeEmitter * | createAnimatedMeshSceneNodeEmitter (scene::IAnimatedMeshSceneNode *node, bool useNormalDirection=true, const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), f32 normalDirectionModifier=100.0f, s32 mbNumber=-1, bool everyMeshVertex=false, u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a particle emitter for an animated mesh scene node.
virtual IParticleAttractionAffector * | createAttractionAffector (const core::vector3df &point, f32 speed=1.0f, bool attract=true, bool affectX=true, bool affectY=true, bool affectZ=true)=0
| Creates a point attraction affector.
virtual IParticleBoxEmitter * | createBoxEmitter (const core::aabbox3df &box=core::aabbox3df(-10, 28,-10, 10, 30, 10), const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a box particle emitter.
virtual IParticleCylinderEmitter * | createCylinderEmitter (const core::vector3df &center, f32 radius, const core::vector3df &normal, f32 length, bool outlineOnly=false, const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a particle emitter for emitting from a cylinder.
virtual IParticleFadeOutAffector * | createFadeOutParticleAffector (const video::SColor &targetColor=video::SColor(0, 0, 0, 0), u32 timeNeededToFadeOut=1000)=0
| Creates a fade out particle affector.
virtual IParticleGravityAffector * | createGravityAffector (const core::vector3df &gravity=core::vector3df(0.0f,-0.03f, 0.0f), u32 timeForceLost=1000)=0
| Creates a gravity affector.
virtual IParticleMeshEmitter * | createMeshEmitter (scene::IMesh *mesh, bool useNormalDirection=true, const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), f32 normalDirectionModifier=100.0f, s32 mbNumber=-1, bool everyMeshVertex=false, u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a mesh particle emitter.
virtual IParticlePointEmitter * | createPointEmitter (const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a point particle emitter.
virtual IParticleRingEmitter * | createRingEmitter (const core::vector3df &center, f32 radius, f32 ringThickness, const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a ring particle emitter.
virtual IParticleRotationAffector * | createRotationAffector (const core::vector3df &speed=core::vector3df(5.0f, 5.0f, 5.0f), const core::vector3df &pivotPoint=core::vector3df(0.0f, 0.0f, 0.0f))=0
| Creates a rotation affector.
virtual IParticleAffector * | createScaleParticleAffector (const core::dimension2df &scaleTo=core::dimension2df(1.0f, 1.0f))=0
| Creates a scale particle affector.
virtual IParticleSphereEmitter * | createSphereEmitter (const core::vector3df &center, f32 radius, const core::vector3df &direction=core::vector3df(0.0f, 0.03f, 0.0f), u32 minParticlesPerSecond=5, u32 maxParticlesPerSecond=10, const video::SColor &minStartColor=video::SColor(255, 0, 0, 0), const video::SColor &maxStartColor=video::SColor(255, 255, 255, 255), u32 lifeTimeMin=2000, u32 lifeTimeMax=4000, s32 maxAngleDegrees=0, const core::dimension2df &minStartSize=core::dimension2df(5.0f, 5.0f), const core::dimension2df &maxStartSize=core::dimension2df(5.0f, 5.0f))=0
| Creates a sphere particle emitter.
virtual IParticleEmitter * | getEmitter ()=0
| Gets the particle emitter, which creates the particles.
| IParticleSystemSceneNode (ISceneNode *parent, ISceneManager *mgr, s32 id, const core::vector3df &position=core::vector3df(0, 0, 0), const core::vector3df &rotation=core::vector3df(0, 0, 0), const core::vector3df &scale=core::vector3df(1.0f, 1.0f, 1.0f))
| Constructor.
virtual void | removeAllAffectors ()=0
| Removes all particle affectors in the particle system.
virtual void | setEmitter (IParticleEmitter *emitter)=0
| Sets the particle emitter, which creates the particles.
virtual void | setParticlesAreGlobal (bool global=true)=0
| Sets if the particles should be global.
virtual void | setParticleSize (const core::dimension2d< f32 > &size=core::dimension2d< f32 >(5.0f, 5.0f))=0
| Sets the size of all particles.

## Detailed Description

A particle system scene node for creating snow, fire, exlosions, smoke...

A scene node controlling a particle System. The behavior of the particles can be controlled by setting the right particle emitters and affectors. You can for example easily create a campfire by doing this:

            scene::IParticleSystemSceneNode* p = scenemgr->addParticleSystemSceneNode();
            p->setParticleSize(core::dimension2d<f32>(20.0f, 10.0f));
            scene::IParticleEmitter* em = p->createBoxEmitter(
                    core::aabbox3d<f32>(-5,0,-5,5,1,5),
                    core::vector3df(0.0f,0.03f,0.0f),
                    40,80, video::SColor(0,255,255,255),video::SColor(0,255,255,255), 1100,2000);
            p->setEmitter(em);
            em->drop();
            scene::IParticleAffector* paf = p->createFadeOutParticleAffector();
            p->addAffector(paf);
            paf->drop();

Definition at line 41 of file IParticleSystemSceneNode.h.

## Constructor & Destructor Documentation

irr::scene::IParticleSystemSceneNode::IParticleSystemSceneNode | ( | ISceneNode * | parent,
|  | ISceneManager * | mgr,
|  | s32 | id,
|  | const core::vector3df & | position = `core::vector3df(0,0,0)`,
|  | const core::vector3df & | rotation = `core::vector3df(0,0,0)`,
|  | const core::vector3df & | scale = `core::vector3df(1.0f, 1.0f, 1.0f)` |
| ) |  |  | `[inline]`

Constructor.

Definition at line 23 of file IParticleSystemSceneNode.h.

References addAffector(), createAnimatedMeshSceneNodeEmitter(), createAttractionAffector(), createBoxEmitter(), createCylinderEmitter(), createFadeOutParticleAffector(), createGravityAffector(), createMeshEmitter(), createPointEmitter(), createRingEmitter(), createRotationAffector(), createScaleParticleAffector(), createSphereEmitter(), getEmitter(), irr::scene::ISceneNode::ISceneNode(), removeAllAffectors(), setEmitter(), setParticlesAreGlobal(), and setParticleSize().

## Member Function Documentation

virtual void irr::scene::IParticleSystemSceneNode::addAffector | ( | IParticleAffector * | affector | ) | `[pure virtual]`

Adds new particle effector to the particle system.

A particle affector modifies the particles. For example, the FadeOut affector lets all particles fade out after some time. It is created and used in this way:

            IParticleAffector* p = createFadeOutParticleAffector();
            addAffector(p);
            p->drop();

Please note that an affector is not necessary for the particle system to work.

Parameters:

  | affector,: | New affector.

Referenced by IParticleSystemSceneNode().

virtual IParticleAnimatedMeshSceneNodeEmitter* irr::scene::IParticleSystemSceneNode::createAnimatedMeshSceneNodeEmitter | ( | scene::IAnimatedMeshSceneNode * | node,
|  | bool | useNormalDirection = `true`,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | f32 | normalDirectionModifier = `100.0f`,
|  | s32 | mbNumber = `-1`,
|  | bool | everyMeshVertex = `false`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a particle emitter for an animated mesh scene node.

Parameters:

  | node,: | Pointer to the animated mesh scene node to emit particles from
  | useNormalDirection,: | If true, the direction of each particle created will be the normal of the vertex that it's emitting from. The normal is divided by the normalDirectionModifier parameter, which defaults to 100.0f.
  | direction,: | Direction and speed of particle emission.
  | normalDirectionModifier,: | If the emitter is using the normal direction then the normal of the vertex that is being emitted from is divided by this number.
  | mbNumber,: | This allows you to specify a specific meshBuffer for the IMesh* to emit particles from. The default value is -1, which means a random meshBuffer picked from all of the meshes meshBuffers will be selected to pick a random vertex from. If the value is 0 or greater, it will only pick random vertices from the meshBuffer specified by this value.
  | everyMeshVertex,: | If true, the emitter will emit between min/max particles every second, for every vertex in the mesh, if false, it will emit between min/max particles from random vertices in the mesh.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleAttractionAffector* irr::scene::IParticleSystemSceneNode::createAttractionAffector | ( | const core::vector3df & | point,
|  | f32 | speed = `1.0f`,
|  | bool | attract = `true`,
|  | bool | affectX = `true`,
|  | bool | affectY = `true`,
|  | bool | affectZ = `true` |
| ) |  |  | `[pure virtual]`

Creates a point attraction affector.

This affector modifies the positions of the particles and attracts them to a specified point at a specified speed per second.

Parameters:

  | point,: | Point to attract particles to.
  | speed,: | Speed in units per second, to attract to the specified point.
  | attract,: | Whether the particles attract or detract from this point.
  | affectX,: | Whether or not this will affect the X position of the particle.
  | affectY,: | Whether or not this will affect the Y position of the particle.
  | affectZ,: | Whether or not this will affect the Z position of the particle.

Returns:
  Pointer to the created particle affector. To add this affector as new affector of this particle system, just call addAffector(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleBoxEmitter* irr::scene::IParticleSystemSceneNode::createBoxEmitter | ( | const core::aabbox3df & | box = `core::aabbox3df(-10, 28,-10, 10, 30, 10)`,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a box particle emitter.

Parameters:

  | box,: | The box for the emitter.
  | direction,: | Direction and speed of particle emission.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleCylinderEmitter* irr::scene::IParticleSystemSceneNode::createCylinderEmitter | ( | const core::vector3df & | center,
|  | f32 | radius,
|  | const core::vector3df & | normal,
|  | f32 | length,
|  | bool | outlineOnly = `false`,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a particle emitter for emitting from a cylinder.

Parameters:

  | center,: | The center of the circle at the base of the cylinder
  | radius,: | The thickness of the cylinder
  | normal,: | Direction of the length of the cylinder
  | length,: | The length of the the cylinder
  | outlineOnly,: | Whether or not to put points inside the cylinder or on the outline only
  | direction,: | Direction and speed of particle emission.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleFadeOutAffector* irr::scene::IParticleSystemSceneNode::createFadeOutParticleAffector | ( | const video::SColor & | targetColor = `video::SColor(0, 0, 0, 0)`,
|  | u32 | timeNeededToFadeOut = `1000` |
| ) |  |  | `[pure virtual]`

Creates a fade out particle affector.

This affector modifies the color of every particle and and reaches the final color when the particle dies. This affector looks really good, if the EMT_TRANSPARENT_VERTEX_ALPHA material is used and the targetColor is video::SColor(0,0,0,0): Particles are fading out into void with this setting.

Parameters:

  | targetColor,: | Color whereto the color of the particle is changed.
  | timeNeededToFadeOut,: | How much time in milli seconds should the affector need to change the color to the targetColor.

Returns:
  Pointer to the created particle affector. To add this affector as new affector of this particle system, just call addAffector(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleGravityAffector* irr::scene::IParticleSystemSceneNode::createGravityAffector | ( | const core::vector3df & | gravity = `core::vector3df(0.0f,-0.03f, 0.0f)`,
|  | u32 | timeForceLost = `1000` |
| ) |  |  | `[pure virtual]`

Creates a gravity affector.

This affector modifies the direction of the particle. It assumes that the particle is fired out of the emitter with huge force, but is loosing this after some time and is catched by the gravity then. This affector is ideal for creating things like fountains.

Parameters:

  | gravity,: | Direction and force of gravity.
  | timeForceLost,: | Time in milli seconds when the force of the emitter is totally lost and the particle does not move any more. This is the time where gravity fully affects the particle.

Returns:
  Pointer to the created particle affector. To add this affector as new affector of this particle system, just call addAffector(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleMeshEmitter* irr::scene::IParticleSystemSceneNode::createMeshEmitter | ( | scene::IMesh * | mesh,
|  | bool | useNormalDirection = `true`,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | f32 | normalDirectionModifier = `100.0f`,
|  | s32 | mbNumber = `-1`,
|  | bool | everyMeshVertex = `false`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a mesh particle emitter.

Parameters:

  | mesh,: | Pointer to mesh to emit particles from
  | useNormalDirection,: | If true, the direction of each particle created will be the normal of the vertex that it's emitting from. The normal is divided by the normalDirectionModifier parameter, which defaults to 100.0f.
  | direction,: | Direction and speed of particle emission.
  | normalDirectionModifier,: | If the emitter is using the normal direction then the normal of the vertex that is being emitted from is divided by this number.
  | mbNumber,: | This allows you to specify a specific meshBuffer for the IMesh* to emit particles from. The default value is -1, which means a random meshBuffer picked from all of the meshes meshBuffers will be selected to pick a random vertex from. If the value is 0 or greater, it will only pick random vertices from the meshBuffer specified by this value.
  | everyMeshVertex,: | If true, the emitter will emit between min/max particles every second, for every vertex in the mesh, if false, it will emit between min/max particles from random vertices in the mesh.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticlePointEmitter* irr::scene::IParticleSystemSceneNode::createPointEmitter | ( | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a point particle emitter.

Parameters:

  | direction,: | Direction and speed of particle emission.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleRingEmitter* irr::scene::IParticleSystemSceneNode::createRingEmitter | ( | const core::vector3df & | center,
|  | f32 | radius,
|  | f32 | ringThickness,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a ring particle emitter.

Parameters:

  | center,: | Center of ring
  | radius,: | Distance of points from center, points will be rotated around the Y axis at a random 360 degrees and will then be shifted by the provided ringThickness values in each axis.
  | ringThickness | : thickness of the ring or how wide the ring is
  | direction,: | Direction and speed of particle emission.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleRotationAffector* irr::scene::IParticleSystemSceneNode::createRotationAffector | ( | const core::vector3df & | speed = `core::vector3df(5.0f, 5.0f, 5.0f)`,
|  | const core::vector3df & | pivotPoint = `core::vector3df(0.0f, 0.0f, 0.0f)` |
| ) |  |  | `[pure virtual]`

Creates a rotation affector.

This affector modifies the positions of the particles and attracts them to a specified point at a specified speed per second.

Parameters:

  | speed,: | Rotation in degrees per second
  | pivotPoint,: | Point to rotate the particles around

Returns:
  Pointer to the created particle affector. To add this affector as new affector of this particle system, just call addAffector(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleAffector* irr::scene::IParticleSystemSceneNode::createScaleParticleAffector | ( | const core::dimension2df & | scaleTo = `core::dimension2df(1.0f, 1.0f)` | ) | `[pure virtual]`

Creates a scale particle affector.

This affector scales the particle to the a multiple of its size defined by the scaleTo variable.

Parameters:

  | scaleTo,: | multiple of the size which the particle will be scaled to until deletion

Returns:
  Pointer to the created particle affector. To add this affector as new affector of this particle system, just call addAffector(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more information.

Referenced by IParticleSystemSceneNode().

virtual IParticleSphereEmitter* irr::scene::IParticleSystemSceneNode::createSphereEmitter | ( | const core::vector3df & | center,
|  | f32 | radius,
|  | const core::vector3df & | direction = `core::vector3df(0.0f, 0.03f, 0.0f)`,
|  | u32 | minParticlesPerSecond = `5`,
|  | u32 | maxParticlesPerSecond = `10`,
|  | const video::SColor & | minStartColor = `video::SColor(255, 0, 0, 0)`,
|  | const video::SColor & | maxStartColor = `video::SColor(255, 255, 255, 255)`,
|  | u32 | lifeTimeMin = `2000`,
|  | u32 | lifeTimeMax = `4000`,
|  | s32 | maxAngleDegrees = `0`,
|  | const core::dimension2df & | minStartSize = `core::dimension2df(5.0f, 5.0f)`,
|  | const core::dimension2df & | maxStartSize = `core::dimension2df(5.0f, 5.0f)` |
| ) |  |  | `[pure virtual]`

Creates a sphere particle emitter.

Parameters:

  | center,: | Center of sphere
  | radius,: | Radius of sphere
  | direction,: | Direction and speed of particle emission.
  | minParticlesPerSecond,: | Minimal amount of particles emitted per second.
  | maxParticlesPerSecond,: | Maximal amount of particles emitted per second.
  | minStartColor,: | Minimal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | maxStartColor,: | Maximal initial start color of a particle. The real color of every particle is calculated as random interpolation between minStartColor and maxStartColor.
  | lifeTimeMin,: | Minimal lifetime of a particle, in milliseconds.
  | lifeTimeMax,: | Maximal lifetime of a particle, in milliseconds.
  | maxAngleDegrees,: | Maximal angle in degrees, the emitting direction of the particle will differ from the original direction.
  | minStartSize,: | Minimal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.
  | maxStartSize,: | Maximal initial start size of a particle. The real size of every particle is calculated as random interpolation between minStartSize and maxStartSize.

Returns:
  Pointer to the created particle emitter. To set this emitter as new emitter of this particle system, just call setEmitter(). Note that you'll have to drop() the returned pointer, after you don't need it any more, see IReferenceCounted::drop() for more informations.

Referenced by IParticleSystemSceneNode().

virtual IParticleEmitter* irr::scene::IParticleSystemSceneNode::getEmitter | ( |  | ) | `[pure virtual]`

Gets the particle emitter, which creates the particles.

Returns:
  The particle emitter. Can be 0 if none is set.

Referenced by IParticleSystemSceneNode().

virtual void irr::scene::IParticleSystemSceneNode::removeAllAffectors | ( |  | ) | `[pure virtual]`

Removes all particle affectors in the particle system.

Referenced by IParticleSystemSceneNode().

virtual void irr::scene::IParticleSystemSceneNode::setEmitter | ( | IParticleEmitter * | emitter | ) | `[pure virtual]`

Sets the particle emitter, which creates the particles.

A particle emitter can be created using one of the createEmitter methods. For example to create and use a simple PointEmitter, call IParticleEmitter* p = createPointEmitter(); setEmitter(p); p->drop();

Parameters:

  | emitter,: | Sets the particle emitter. You can set this to 0 for removing the current emitter and stopping the particle system emitting new particles.

Referenced by IParticleSystemSceneNode().

virtual void irr::scene::IParticleSystemSceneNode::setParticlesAreGlobal | ( | bool | global = `true` | ) | `[pure virtual]`

Sets if the particles should be global.

If they are, the particles are affected by the movement of the particle system scene node too, otherwise they completely ignore it. Default is true.

Referenced by IParticleSystemSceneNode().

virtual void irr::scene::IParticleSystemSceneNode::setParticleSize | ( | const core::dimension2d< f32 > & | size = `core::dimension2d< f32 >(5.0f, 5.0f)` | ) | `[pure virtual]`

Sets the size of all particles.

Referenced by IParticleSystemSceneNode().

The documentation for this class was generated from the following file:

- IParticleSystemSceneNode.h

| The Irrlicht Engine Documentation © 2003-2010 by Nikolaus Gebhardt. Generated on Sun Oct 24 12:42:07 2010 by Doxygen (1.6.2)